'
' IPX Chat
'
' Chat program
'
' (C) 1997 by MediaTech Software GmbH
'

'
' This source is formatted with a tab size of 2!
'

$CPU 80386   				    								' 80386 CPU support
$ERROR ALL OFF      					          ' Disable error trapping
$FLOAT PROCEDURE												' Use math unit PROCEDURE
$LIB ALL OFF  				                  ' Disable all libraries
$OPTIMIZE SIZE        				          ' Optimize for program size
$OPTION CNTLBREAK OFF   				        ' Disable control-break
$DIM ALL																' Everything have to be declared

$COMPILE EXE 	"IPXCHAT.EXE"          		' Compile to Exe
$LINK 				"IPXUNIT.PBU"							' Link IPX Unit
$INCLUDE 			"IPXUNIT.INC"							' IPX Unit Declarations

DEFINT A-Z

DIM Handle 				AS STRING							' Handle of User
DIM UserInput 		AS STRING							' Current Input-line
DIM KeyPress 			AS STRING							' Pressed Key
DIM MyAddress 		AS STRING							' Own Network address
DIM Report 				AS STRING							' Report Other Chat
DIM XCursor 			AS INTEGER			      ' Location in Input-line


IPX.Init "", "", "", ""									' IPX-Routine Initialization

PRINT "IPX Chat 1.0"										' Print Header
PRINT STRING$(80, "-");
PRINT

IF NOT IPX.Installed THEN								' IPX-Driver loaded?
	PRINT "- Error: IPX-Driver not loaded!"
  END
ELSE
	PRINT "- IPX detected"
END IF

IF NOT IPX.OpenSocket(&H4711) THEN			' can the socket be opened?
	PRINT "- Error: IPX Socket cannot be opened"
  END
ELSE
	PRINT "- IPX Socket opened"
END IF

MyAddress = MakeHexStr(IPX.GetInternetworkAddress)
PRINT "- Local Address is "; LEFT$(MyAddress, 8); ":"; RIGHT$(MyAddress, 12)
PRINT

LINE INPUT "Please enter your handle: ", Handle
PRINT
PRINT "[RETURN] Send Line"
PRINT "  [BACK] Delete Line"
PRINT "   [ESC] End Program"
PRINT

XCursor = 1

COLOR 15, 0
PRINT Handle; "> ";

COLOR 7, 0
LOCATE ,, 1


DO

	DO
    Report = IPX.RecvPacket(&H4711)		' Check IPX-Buffer
    IF LEN(Report) THEN
      LOCATE , 1
      PRINT SPACE$(79);
      LOCATE , 1
      PRINT Report

			COLOR 15, 0
			PRINT Handle; "> "; UserInput;
      COLOR 7, 0
    END IF

  	KeyPress = INKEY$										' Read Keyboard
  LOOP UNTIL LEN(KeyPress)

  SELECT CASE KeyPress
    CASE CHR$(8)												' BACK: Delete Line
      IF XCursor > 1 THEN
      	DECR XCursor
        LOCATE , XCursor + LEN(Handle) + 2
        PRINT " ";
        LOCATE , XCursor + LEN(Handle) + 2
        UserInput = LEFT$(UserInput, LEN(UserInput) - 1)
      END IF

    CASE CHR$(13)												' RETURN: Send Line
    	IF XCursor > 1 THEN
	    	IPX.SendPacket &H4711, Handle + ": " + UserInput

	      LOCATE , 1
	      PRINT SPACE$(79);
	      LOCATE , 1
	      PRINT Handle + ": " + UserInput

  	    UserInput = ""
	      XCursor = 1

				COLOR 15, 0
				PRINT Handle; "> ";
	      COLOR 7, 0
      END IF

  	CASE CHR$(27)												' ESC: End Program

    CASE ELSE														' <Other>: Print key
    	IF XCursor < 77 - LEN(Handle) AND ASCII(KeyPress) >= 32 THEN
      	PRINT KeyPress;
        UserInput = UserInput + KeyPress
        INCR XCursor
      ELSE
      	SOUND 100, .5
      END IF

  END SELECT

LOOP UNTIL KeyPress = CHR$(27)		  		' Until [ESC] is pressed

PRINT
PRINT "- Chat has been Terminated"

IPX.CloseSocket &H4711									' Close Socket

PRINT "- Socket Closed"
PRINT "- Exit"
